package maze.searchers;

import static org.junit.Assert.*;

import java.util.HashSet;
import java.util.function.Supplier;


public class SearcherTest {

	public static void testRetrieval(Supplier<Searcher<Integer>> maker) {
		Searcher<Integer> searcher = maker.get();
		assertTrue(searcher.isEmpty());
		HashSet<Integer> wentIn = new HashSet<>();
		for (int i = 0; i < 10000; i++) {
			wentIn.add(i);
			searcher.add(i);
		}
		assertFalse(searcher.isEmpty());
		
		while (!searcher.isEmpty()) {
			int peeked = searcher.peek();
			assertTrue(wentIn.contains(peeked));
			int oldSize = searcher.size();
			int value = searcher.remove();
			assertEquals(oldSize - 1, searcher.size());
			assertEquals(peeked, value);
			wentIn.remove(value);
		}
	}
	
	public static void testCapacity(Supplier<Searcher<Integer>> maker) {
		Searcher<Integer> searcher = maker.get();
		int capacityTest = 100;
		for (int i = 0; i < 10; i++) {
			for (int j = 0; j < capacityTest; j++) {
				searcher.add(j);
			}
			while (!searcher.isEmpty()) {
				searcher.remove();
			}
			assertTrue(searcher.capacity() <= 2 * capacityTest);
		}
	}
}
